import { httpApp } from "@/plugins/axiosIndex";
import { pickBy } from "lodash-es";
import { object2QueryString } from "@/utils/utils";

// realtime-monitoring
export function invigilateList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/list?" + object2QueryString(data),
    {}
  );
}
export function invigilateVideoList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/list/video?" + object2QueryString(data),
    {}
  );
}

// online-patrol
export function patrolList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/patrol/list?" + object2QueryString(data),
    {}
  );
}

// 强制/手动交卷接口
export function invigilateFinish(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post("/api/admin/invigilate/finish", data);
}
// 结束监考接口
export function invigilateExamFinish(examId) {
  return httpApp.post("/api/admin/invigilate/exam/finish?examId=" + examId, {});
}

// 考试列表
export function examList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post("/api/admin/exam/list?" + object2QueryString(data), {});
}
// 监考老师::考试批次列表
export function examBatchList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/sys/exam/query?" + object2QueryString(data),
    {}
  );
}
// 考试属性统计接口
export function examPropCount(examId) {
  return httpApp.post("/api/admin/exam/prop/count?examId=" + examId, {});
}

export function communicationList({
  examActivityId,
  pageNumber = 1,
  pageSize = 10,
}) {
  const data = pickBy(
    { examActivityId, pageNumber, pageSize },
    (v) => v !== ""
  );
  return httpApp.post(
    "/api/admin/monitor/call/list?" + object2QueryString(data),
    {},
    {
      noErrorMessage: true,
    }
  );
}

export function communicationOver(callCancelBackendMobile) {
  return httpApp.post(
    "/api/admin/monitor/call/cancel",
    { callCancelBackendMobile },
    {
      noErrorMessage: true,
    }
  );
}

// invigilation-detail
export function invigilationHistoryList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/history/list?" + object2QueryString(data),
    {}
  );

  // {
  //   "breachStatus": 0,
  //   "examActivityId": 0,
  //   "examId": 0,
  //   "examRecordId": 0,
  //   "examStudentId": 0,
  //   "exceptionCount": 0,
  //   "finishType": "",
  //   "identity": "",
  //   "multipleFaceCount": 0,
  //   "name": "",
  //   "roomCode": "",
  //   "roomName": "",
  //   "status": "",
  //   "statusCode": "",
  //   "updateTime": "",
  //   "warningCount": 0
  // }
}

// waining-manage
export function invigilationWarningList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/warn/list?" + object2QueryString(data),
    {}
  );
}
// TODO:批量处理违纪
export function batchInvigilation(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/warn/list?" + object2QueryString(data),
    {}
  );
}
// TODO:清除未阅
export function clearInvigilationUnreadWarningList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/warn/list?" + object2QueryString(data),
    {}
  );
}

// warning-detail
// 获取当前学生直播视频流
export function warningStudentDetail({ recordId }) {
  const data = {
    recordId,
  };
  return httpApp.post(
    "/api/admin/monitor/call/query?" + object2QueryString(data),
    {}
  );
}
// 获取预警详情信息
export function invigilateDetail(recordId) {
  return httpApp.post(
    "/api/admin/invigilate/list/detail?examRecordId=" + recordId,
    {}
  );
}
// 学生违纪处理
export function updateBreachInfo(datas) {
  const data = pickBy(datas, (v) => v !== "");

  return httpApp.post("/api/admin/invigilate/breach", data);
}

// reexam-apply
export function reexamApplyList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/reexam/list?" + object2QueryString(data),
    {}
  );
}
export function applyReexam(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post("/api/admin/invigilate/reexam/apply", data);
}

// reexam-pending
export function reexamPendingList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/reexam/list_not_done?" + object2QueryString(data),
    {}
  );
}
export function checkReexamApply(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post("/api/admin/invigilate/reexam/auditing", data);
}

// reexam-checked
export function reexamCheckedList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/reexam/list_done?" + object2QueryString(data),
    {}
  );
}

// progress-detail
export function progressDetailList(datas) {
  const data = pickBy(datas, (v) => v !== "");
  return httpApp.post(
    "/api/admin/invigilate/progress/list?" + object2QueryString(data),
    {}
  );
}
